/**********************************************************

This software is part of J.-S. Caux's ABACUS library.

Copyright (c) J.-S. Caux.

-----------------------------------------------------------

File:  ABACUS_XXZ_VOA.h

Purpose:  Declares classes for XXZ in zero field:  Vertex Operator Approach

***********************************************************/

#ifndef ABACUS_XXZ_VOA_H
#define ABACUS_XXZ_VOA_H

#include "ABACUS.h"


namespace ABACUS {

  DP I_xi_integral (DP xi, DP rho, DP req_prec, int max_nr_pts);

  /*********************  TWO SPINONS ********************/
  DP Szz_XXZ_h0_2spinons (DP k, DP omega, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons (Vect_DP args, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_alt (Vect_DP args, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_omega (Vect_DP args, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_omega_alt (Vect_DP args, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_intomega (Vect_DP args, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_intomega_alt (Vect_DP args, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_check_sumrule (DP Delta, DP req_prec, int max_nr_pts, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_check_sumrule_alt (DP Delta, DP req_prec, int max_nr_pts, Integral_table Itable);
  DP Fixed_k_sumrule_omega_Szz_XXZ_h0_N (DP Delta, DP k);
  DP GSE_XXZ_h0 (DP Delta, DP req_prec, int max_nr_pts);
  DP Fixed_k_sumrule_omega_Szz_XXZ_h0 (DP Delta, DP k, DP req_prec, int max_nr_pts);
  DP Szz_XXZ_h0_2spinons_check_fixed_k_Szz_sumrule (DP Delta, DP k, DP req_prec, int max_nr_pts, Integral_table Itable);
  DP Szz_XXZ_h0_2spinons_check_fixed_k_Szz_sumrule_alt (DP Delta, DP k, DP req_prec, int max_nr_pts, Integral_table Itable);

  //******************************** Functions to produce files similar to ABACUS **********************************
  void Produce_Szz_XXZ_h0_2spinons_file (DP Delta, int N, int Nomega, DP omegamax, Integral_table Itable);
  void Produce_Szz_XXZ_h0_2spinons_fixed_K_file (DP Delta, DP Kover2PI, int Nomega, Integral_table Itable);

} // namespace ABACUS

#endif
