import argparse
import plotly.graph_objects as go
import numpy

parser = argparse.ArgumentParser()
parser.add_argument('omegafile', help='Omega filename')
parser.add_argument('dsffile', help='DSF filename')
args = parser.parse_args()

omega = numpy.loadtxt(args.omegafile)
dsf = numpy.loadtxt(args.dsffile)

x = [o for o in omega]
y = [d for d in dsf]

fig = go.Figure(data=go.Scatter(x=x, y=y))
fig.update_layout(title=args.dsffile.rpartition('/')[2])
fig.show()


